using System.ComponentModel;
using System.Windows;
using IGExtensions.Common.Maps.Imagery;
using Infragistics.Controls.Maps;

namespace IGExtensions.Common.Maps.Imagery
{
    public class CloudMadeMapImageryEx : CloudMadeMapImagery
    {
        //public const string ImageryStylePropertyName = "ImageryStyle";
        //public static readonly DependencyProperty ImageryStyleProperty = DependencyProperty.Register(
        //    ImageryStylePropertyName, typeof(double), typeof(CloudMadeMapImageryEx),
        //    new PropertyMetadata(90.0, (sender, e) =>
        //        ((CloudMadeMapImageryEx)sender).OnPropertyChanged(ImageryStylePropertyName, e.OldValue, e.NewValue)));
        ///// <summary>
        ///// Gets or sets the ImageryStyle property 
        ///// </summary>
        //public double ImageryStyle
        //{
        //    get { return (double)GetValue(ImageryStyleProperty); }
        //    set { SetValue(ImageryStyleProperty, value); }
        //}


        public const string ImageryStylePropertyName = "ImageryStyle";
        public static readonly DependencyProperty ImageryStyleProperty = DependencyProperty.Register(
            ImageryStylePropertyName, typeof(CloudMadeMapImageryStyle), typeof(CloudMadeMapImageryEx),
            new PropertyMetadata(CloudMadeMapImageryStyle.FineLineMapStyle, (sender, e) =>
        {
            (sender as CloudMadeMapImageryEx).OnPropertyChanged(ImageryStylePropertyName, e.OldValue, e.NewValue);
        })); 
        /// <summary>
        /// Gets or sets the ImageryStyle property 
        /// </summary>
        public CloudMadeMapImageryStyle ImageryStyle
        {
            get { return (CloudMadeMapImageryStyle)GetValue(ImageryStyleProperty); }
            set { SetValue(ImageryStyleProperty, value); }
        }

        private void OnPropertyChanged(string propertyName, object oldValue, object newValue)
        {
            switch (propertyName)
            {
                case ImageryStylePropertyName:
                    var parameter = (int)ImageryStyle;
                    this.Parameter = parameter.ToString();
                    //CloudView.OnKeyPropertyChanged();
                    //View.NeedsRefresh();)
                    break;
                //case ParameterPropertyName:
                //    CloudView.OnParameterPropertyChanged();
                //    View.NeedsRefresh();
                //    break;
            }

            OnPropertyUpdated(propertyName, oldValue, newValue);
        }
    }
}